--[[
	##AddOn	: CooldownIcons R(evamped)
	##Subfile 	: range.lua
	##Author  : Hati ( xhatix on wowace.com )
--]]
local CIR = CooldownIconsR
local GetTime = _G.GetTime


local updater = CreateFrame("Frame","CIR_RangeUpdater")
updater:SetScript("OnUpdate", function(self,elapsed)
	if not CIR.updateFrequency then return end
	if not self.lastUpdate then
		self.lastUpdate = 0
	end
	self.lastUpdate = self.lastUpdate + elapsed
	while (self.lastUpdate >= CIR.updateFrequency) do
        if CIR.events.CIR_RANGEEVENT then
            for _,obj in pairs(CIR.events.CIR_RANGEEVENT) do
                if CIR.icons[obj].name then
                    CIR:ProcessScriptForIcon(CIR.db.char.icondb[obj].script,CIR.icons[obj])
                end
            end
        end
		for k,v in ipairs(CIR.rangeCheck) do
			local icon = CIR.icons[v]
			local b =  nil
            if not icon then return end
			if icon.active and not icon.forcedrange then
				if icon.type=='spell' then
					if type(icon.watch) == "number" then
						b=IsSpellInRange(GetSpellInfo(icon.watch),"target") 
					else
						b=IsSpellInRange(icon.watch,"target") 
					end
				else
					b=IsItemInRange(icon.watch,"target")
				end
				if b==0 then
					icon.texture:SetVertexColor(unpack(CIR.db.char.gMisc.gRangeColor or {1,0,0,1}))
                    icon.inRange=false
				elseif (b==1 or b==nil) then
					icon.texture:SetVertexColor(1,1,1,1)
                    icon.inRange=true
				end
			end
		end
		self.lastUpdate = self.lastUpdate - CIR.updateFrequency
	end
end)

